"""main.py - sets up the main application environment and launches the intro
"""

import cProfile
import pstats

import pygame

import context
import settings
import intro
import game
import credits


def start_context():
    # developer convenience to bypass intro and/or menu
    if settings.bypass_menu == 'game':
        context.run(game.Game())
    elif settings.bypass_menu == 'credits':
        context.run(credits.Credits())
    else:
        context.run(intro.Intro())


def main():
    global start_context    # runctx requires this

    pygame.init()
    settings.screen = pygame.display.set_mode(settings.resolution, settings.display_flags)
    settings.screen_rect = settings.screen.get_rect()

    if settings.profile:
        cProfile.runctx('start_context()', globals(), locals(), 'prof.dat')
        p = pstats.Stats('prof.dat')
        p.sort_stats('time').print_stats()
    else:
        start_context()
